version "4.6.0"

class LampWeapon : Weapon
{
	bool on;

	Default
	{
		Weapon.SlotNumber 1;
	}

	States
	{
	Spawn:
		LYTE C -1;
		Stop;
	Select:
		LYTE A 1 A_Raise;
		Loop;
	Deselect:
		LYTE A 0 {
			invoker.on = false;
			invoker.Owner.A_RemoveLight('thelyte');
		}
		LYTE A 1 A_Lower;
		Loop;
	Ready:
		LYTE A 0 {
			if (invoker.on)
			{
				return ResolveState(1);
			}
			return ResolveState(2);
		}
		LYTE B 0;
		"####" "#" 1 A_WeaponReady;
		Wait;
	Fire:
		"####" "#" 5;
		"####" "#" 0 {
			invoker.on = !invoker.on;
			if (invoker.on) {
				invoker.Owner.A_AttachLightDef('thelyte', 'lyte');
				return ResolveState(2);
			} else {
				invoker.Owner.A_RemoveLight('thelyte'); // Causes heap-use-after-free
				return ResolveState(1);
			}
		}
		LYTE A 5;
		Goto Ready;
		LYTE B 5;
		Goto Ready;
	}
}
